import java.awt.Button;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

class UE20Aufgabe25 extends Frame {

	static int[][] erzeugeMatrix() {
		int[][] matrix = { { 15, 14, 13, 12 }, { 11, 10, 9, 8 },
				{ 7, 6, 5, 4 }, { 3, 2, 1, 0 } };
		// int[][] matrix = { { 0, 1, 2, 3 }, { 4, 5, 6, 7 }, { 8, 9, 10, 11 },
		// { 12, 13, 14, 15 } };
		return matrix;
	}

	public static void main(String[] args) {
		VerschiebeSpiel spiel = new VerschiebeSpiel(erzeugeMatrix());
		spiel.setVisible(true);
	}
}

class VerschiebeSpiel extends Frame {

	final static String LEER = "";
	private int[][] matrix;
	private Button[][] buttons;
	final int REIHEN;
	final int SPALTEN;

	public VerschiebeSpiel(int[][] matrix) {
		super("VerschiebeSpiel");
		this.matrix = matrix;
		this.REIHEN = matrix.length;
		this.SPALTEN = matrix[0].length;
		this.buttons = new Button[this.REIHEN][this.SPALTEN];
		this.setLayout(new GridLayout(this.REIHEN, this.SPALTEN));

		for (int r = 0; r < this.REIHEN; r++) {
			for (int s = 0; s < this.SPALTEN; s++) {
				if (this.matrix[r][s] != 0) {
					this.buttons[r][s] = new Button("" + matrix[r][s]);
				} else {
					this.buttons[r][s] = new Button(VerschiebeSpiel.LEER);
				}
				this.buttons[r][s].addActionListener(new ClickListener(r, s,
						this.buttons));
				this.add(this.buttons[r][s]);
			}
		}
		this.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		this.pack();
	}
}

class ClickListener implements ActionListener {

	private int reihe;
	private int spalte;
	private Button[][] buttons;

	ClickListener(int r, int s, Button[][] b) {
		this.reihe = r;
		this.spalte = s;
		this.buttons = b;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		Position thisPos = new Position(this.reihe, this.spalte);
		Position leerPos = this.getLeerPosition();
		if (thisPos.equals(leerPos)) { // leerer Button geklickt
			return;
		}
		if (!thisPos.istNachbar(leerPos)) {
			return; // leerer Button ist kein Nachbarfeld des geklickten Button
		}

		// "verschieben"
		this.buttons[leerPos.reihe][leerPos.spalte]
				.setLabel(this.buttons[thisPos.reihe][thisPos.spalte]
						.getLabel());
		this.buttons[thisPos.reihe][thisPos.spalte]
				.setLabel(VerschiebeSpiel.LEER);

		// Ende ueberpruefen
		if (istEnde()) {
			for (int r = 0; r < this.buttons.length; r++) {
				for (int s = 0; s < this.buttons[0].length; s++) {
					this.buttons[r][s].setEnabled(false);
				}
			}
		}

	}

	private Position getLeerPosition() {
		for (int r = 0; r < this.buttons.length; r++) {
			for (int s = 0; s < this.buttons[0].length; s++) {
				if (this.buttons[r][s].getLabel().equals(VerschiebeSpiel.LEER)) {
					return new Position(r, s);
				}
			}
		}
		return null; // kann nicht sein
	}

	private boolean istEnde() {
		if (!this.buttons[0][0].getLabel().equals(VerschiebeSpiel.LEER)) {
			return false;
		}
		int zahl = 1;
		for (int r = 0; r < this.buttons.length; r++) {
			for (int s = 0; s < this.buttons[0].length; s++) {
				if (r == 0 && s == 0)
					continue;
				if (!this.buttons[r][s].getLabel().equals(zahl + "")) {
					return false;
				}
				zahl++;
			}
		}
		return true;
	}
}

class Position {
	int reihe;
	int spalte;

	Position(int r, int s) {
		this.reihe = r;
		this.spalte = s;
	}

	@Override
	public boolean equals(Object obj) {
		Position pos = (Position) obj;
		return this.reihe == pos.reihe && this.spalte == pos.spalte;
	}

	public boolean istNachbar(Position pos) {
		return (this.spalte == pos.spalte && Math.abs(this.reihe - pos.reihe) == 1)
				|| (this.reihe == pos.reihe && Math.abs(this.spalte
						- pos.spalte) == 1);
	}
}