import java.util.ArrayList;

interface IntTester {
	public boolean test(int value);
}

class IntArrayList extends ArrayList<Integer> {

	public IntArrayList() {
		super();
	}

	public int sum() {
		int res = 0;
		for (int value : this) {
			res += value;
		}
		return res;
	}

	public IntArrayList filter(IntTester tester) {
		IntArrayList res = new IntArrayList();
		for (int value : this) {
			if (tester.test(value)) {
				res.add(value);
			}
		}
		return res;
	}
}

// Gruppe A
class OddValueTester implements IntTester {

	@Override
	public boolean test(int value) {
		return value % 2 != 0;
	}

}

// Gruppe B
class EvenValueTester implements IntTester {

	@Override
	public boolean test(int value) {
		return value % 2 == 0;
	}

}

public class UE20Aufgabe29 {

	public static void main(String[] args) {
		IntArrayList list = new IntArrayList();
		for (int i = 1; i <= 10; i++) {
			list.add(i);
		}
		System.out.println(list.filter(new OddValueTester()).sum());
		System.out.println(list.filter(new EvenValueTester()).sum());
	}

}
