

interface Chiffrierung {
	public char chiffrieren(char zeichen);
	public char dechiffrieren(char zeichen);
}

class TabellenChiffrierung implements Chiffrierung {
	
	char[] geheimtextalphabet;
	
	/**
	@param alphabet muss 26 Elemente enthalten
	*/
	public TabellenChiffrierung(char[] alphabet) {
		this.geheimtextalphabet = alphabet;
	}
	
	public char chiffrieren(char zeichen) {
		if (zeichen >= 'a' && zeichen <= 'z') {
			return this.geheimtextalphabet[zeichen - 'a'];
		}
		return zeichen;
	}
	
	public char dechiffrieren(char zeichen) {
		for (int i=0; i<this.geheimtextalphabet.length; i++) {
			if (zeichen == this.geheimtextalphabet[i]) {
				return (char)('a' + i);
			}
		}
		return zeichen;
	}
	
	/**
	Alternative zum Konstruktor
	@param alphabet muss 26 Elemente enthalten
	*/
	protected void setzeGeheimtextalphabet(char[] alphabet) {
		this.geheimtextalphabet = alphabet;
	}
}


class StellenVerschiebung extends TabellenChiffrierung
  implements Chiffrierung {
	
	/**
	@param stellen es muss gelten: 0 <= stellen <= 26
	*/
	public StellenVerschiebung(int stellen) {
		super(null); // alphabet wird spaeter gesetzt
		char[] alphabet = new char[26];
		char zeichen = (char)('a' + stellen);
		for (int i=0; i<26; i++) {
			alphabet[i] = zeichen;
			if (zeichen == 'z') {
				zeichen = 'a';
			} else {
				zeichen = (char)(zeichen + 1);
			}
		}
		this.setzeGeheimtextalphabet(alphabet);
	}
}

class Verschluesselung {
	
	public static String verschluesseln(String klartext, Chiffrierung schluessel) {
		String geheimtext = "";
		for (int i=0; i<klartext.length(); i++) {
			geheimtext = geheimtext + schluessel.chiffrieren(klartext.charAt(i));
		}
		return geheimtext;
	}
	
	public static String entschluesseln(String geheimtext, Chiffrierung schluessel) {
		String klartext = "";
		for (int i=0; i<geheimtext.length(); i++) {
			klartext = klartext + schluessel.dechiffrieren(geheimtext.charAt(i));
		}
		return klartext;
	}
}

public class UE20Aufgabe3 {
	
	public static void main(String[] args) {
		String klartext = IO.readString("Text eingeben: ");
		Chiffrierung chiffre = new StellenVerschiebung(3);
		String geheimtext;
		System.out.println("Verschluesselter Text: " +
		                   (geheimtext = Verschluesselung.verschluesseln(klartext, chiffre)));
		System.out.println("Entschluesselter Text: " +
				Verschluesselung.entschluesseln(geheimtext, chiffre));
	}
	
}
		